--------------------------------------------------------------------------------
-- GLOBALS
--------------------------------------------------------------------------------

Global( "wtMainPanel", nil )
Global( "wtHonorText", nil )
Global( "wtKillsText", nil )
Global( "Drag", false )

--------------------------------------------------------------------------------
-- EVENT HANDLERS
--------------------------------------------------------------------------------
-- "EVENT_AVATAR_SECONDARY_TARGET_CHANGED"
function OnEventTargetChanged( params )
	local targetId = avatar.GetTarget()
	if targetId == nil then
		wtMainPanel:Show( false )
	else
		if unit.IsPlayer( targetId ) then
			mission.DNDRegister( wtMainPanel, GetDNDId( DND_WIDGET_MOVE, 7 ), false )
			wtMainPanel:Show( true )
		else
			wtMainPanel:Show( false )
		end
	end
	local hinfo = unit.GetHonorInfo( targetId )
	wtHonorText:SetVal( "value", common.FormatInt( hinfo.value, "%d" ) )
	wtKillsText:SetVal( "value", common.FormatInt( hinfo.kills, "%d" ) )
end

function OnEventDNDPickAttempt( params )
	if GetDNDItem(params.srcId) == 700 then
		Drag = true
	end
end

function OnEventDNDDragTo( params )
	if Drag == true then
		local place = wtMainPanel:GetPlacementPlain()
		place.posX = params.posX
		place.posY = params.posY
		wtMainPanel:SetPlacementPlain( place )
	end
end

function OnEventDNDDropAttempt( params )	
	mission.DNDConfirmDropAttempt()
	Drag = false
end

function GetDNDId( container, item )
	return container * DND_CONTAINER_STEP + item
end

function GetDNDItem( id )
	return math.mod( id, DND_CONTAINER_STEP )
end

function OnToggleUI( params )
	wtMainPanel:Show( params.visible )
	if params.visible then
		mission.DNDRegister( wtMainPanel, GetDNDId( DND_WIDGET_MOVE, 7 ), false )
	end
end

--------------------------------------------------------------------------------
-- INITIALIZATION
--------------------------------------------------------------------------------
function Init()
	common.RegisterEventHandler( OnEventTargetChanged, "EVENT_AVATAR_SECONDARY_TARGET_CHANGED" )
	common.RegisterEventHandler( OnEventDNDPickAttempt, "EVENT_DND_PICK_ATTEMPT" )
	common.RegisterEventHandler( OnEventDNDDragTo, "EVENT_DND_DRAG_TO" )
	common.RegisterEventHandler( OnEventDNDDropAttempt, "EVENT_DND_DROP_ATTEMPT" )
	common.RegisterEventHandler( OnToggleUI, "SCRIPT_TOGGLE_UI")

	wtMainPanel = mainForm:GetChildChecked( "MainPanel", false )
	wtMainPanel:Show(false)
	wtHonorText = wtMainPanel:GetChildChecked( "HonorText", false )
	wtKillsText = wtMainPanel:GetChildChecked( "KillsText", false )

	mission.DNDRegister( wtMainPanel, GetDNDId( DND_WIDGET_MOVE, 700 ), false )
end
--------------------------------------------------------------------------------
Init()
--------------------------------------------------------------------------------
